/* InfoBox.c generated by valac 0.38.10, the Vala compiler
 * generated from InfoBox.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <float.h>
#include <math.h>


#define NETWORK_WIDGETS_TYPE_INFO_BOX (network_widgets_info_box_get_type ())
#define NETWORK_WIDGETS_INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox))
#define NETWORK_WIDGETS_INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBoxClass))
#define NETWORK_WIDGETS_IS_INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX))
#define NETWORK_WIDGETS_IS_INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_INFO_BOX))
#define NETWORK_WIDGETS_INFO_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBoxClass))

typedef struct _NetworkWidgetsInfoBox NetworkWidgetsInfoBox;
typedef struct _NetworkWidgetsInfoBoxClass NetworkWidgetsInfoBoxClass;
typedef struct _NetworkWidgetsInfoBoxPrivate NetworkWidgetsInfoBoxPrivate;

#define NETWORK_WIDGETS_TYPE_DEVICE_ITEM (network_widgets_device_item_get_type ())
#define NETWORK_WIDGETS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem))
#define NETWORK_WIDGETS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_DEVICE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))

typedef struct _NetworkWidgetsDeviceItem NetworkWidgetsDeviceItem;
typedef struct _NetworkWidgetsDeviceItemClass NetworkWidgetsDeviceItemClass;
enum  {
	NETWORK_WIDGETS_INFO_BOX_0_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES
};
static GParamSpec* network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS
};
static guint network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS] = {0};

struct _NetworkWidgetsInfoBox {
	GtkGrid parent_instance;
	NetworkWidgetsInfoBoxPrivate * priv;
};

struct _NetworkWidgetsInfoBoxClass {
	GtkGridClass parent_class;
};

struct _NetworkWidgetsInfoBoxPrivate {
	NMDevice* _device;
	NetworkWidgetsDeviceItem* _owner;
	GtkLabel* ip4address;
	GtkLabel* ip6address;
	GtkLabel* mask;
	GtkLabel* router;
	GtkLabel* sent;
	GtkLabel* received;
	GtkLabel* ip6address_head;
};

struct _Block8Data {
	int _ref_count_;
	NetworkWidgetsInfoBox* self;
	gint i;
	GPtrArray* addresses;
};


static gpointer network_widgets_info_box_parent_class = NULL;

GType network_widgets_info_box_get_type (void) G_GNUC_CONST;
GType network_widgets_device_item_get_type (void) G_GNUC_CONST;
#define NETWORK_WIDGETS_INFO_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBoxPrivate))
NetworkWidgetsInfoBox* network_widgets_info_box_new_from_device (NMDevice* device);
NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_device (GType object_type, NMDevice* device);
NetworkWidgetsInfoBox* network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner);
NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_owner (GType object_type, NetworkWidgetsDeviceItem* owner);
NMDevice* network_widgets_device_item_get_item_device (NetworkWidgetsDeviceItem* self);
void network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self, const gchar* sent_bytes, const gchar* received_bytes);
#define NETWORK_UNKNOWN_STR _ ("Unknown")
void network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self);
NMDevice* network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda7_ (Block8Data* _data8_, NMIPAddress* addr);
static void ____lambda7__gfunc (gconstpointer data, gpointer self);
NetworkWidgetsDeviceItem* network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self);
NetworkWidgetsInfoBox* network_widgets_info_box_new (void);
NetworkWidgetsInfoBox* network_widgets_info_box_construct (GType object_type);
static void network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self, NMDevice* value);
static void network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self, NetworkWidgetsDeviceItem* value);
static GObject * network_widgets_info_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self);
static void __network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender, guint new_state, guint old_state, guint reason, gpointer self);
static void network_widgets_info_box_finalize (GObject * obj);
static void _vala_network_widgets_info_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_network_widgets_info_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_device (GType object_type, NMDevice* device) {
	NetworkWidgetsInfoBox * self = NULL;
	NMDevice* _tmp0_;
	g_return_val_if_fail (device != NULL, NULL);
	_tmp0_ = device;
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "device", _tmp0_, NULL);
	return self;
}


NetworkWidgetsInfoBox* network_widgets_info_box_new_from_device (NMDevice* device) {
	return network_widgets_info_box_construct_from_device (NETWORK_WIDGETS_TYPE_INFO_BOX, device);
}


NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_owner (GType object_type, NetworkWidgetsDeviceItem* owner) {
	NetworkWidgetsInfoBox * self = NULL;
	NetworkWidgetsDeviceItem* _tmp0_;
	NetworkWidgetsDeviceItem* _tmp1_;
	NMDevice* _tmp2_;
	NMDevice* _tmp3_;
	g_return_val_if_fail (owner != NULL, NULL);
	_tmp0_ = owner;
	_tmp1_ = owner;
	_tmp2_ = network_widgets_device_item_get_item_device (_tmp1_);
	_tmp3_ = _tmp2_;
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "owner", _tmp0_, "device", _tmp3_, NULL);
	_g_object_unref0 (_tmp3_);
	return self;
}


NetworkWidgetsInfoBox* network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner) {
	return network_widgets_info_box_construct_from_owner (NETWORK_WIDGETS_TYPE_INFO_BOX, owner);
}


void network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self, const gchar* sent_bytes, const gchar* received_bytes) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sent_bytes != NULL);
	g_return_if_fail (received_bytes != NULL);
	_tmp1_ = sent_bytes;
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = NETWORK_UNKNOWN_STR;
	}
	_tmp2_ = self->priv->sent;
	gtk_label_set_label (_tmp2_, _tmp0_);
	_tmp4_ = received_bytes;
	_tmp3_ = _tmp4_;
	if (_tmp3_ == NULL) {
		_tmp3_ = NETWORK_UNKNOWN_STR;
	}
	_tmp5_ = self->priv->received;
	gtk_label_set_label (_tmp5_, _tmp3_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gint g_ptr_array_get_length (GPtrArray* self) {
	gint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->len;
	result = (gint) _tmp0_;
	return result;
}


static void g_ptr_array_set_length (GPtrArray* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	g_ptr_array_set_size (self, _tmp0_);
}


static Block8Data* block8_data_ref (Block8Data* _data8_) {
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		NetworkWidgetsInfoBox* self;
		self = _data8_->self;
		_g_ptr_array_unref0 (_data8_->addresses);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}


static gpointer _g_ptr_array_ref0 (gpointer self) {
	return self ? g_ptr_array_ref (self) : NULL;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void ___lambda7_ (Block8Data* _data8_, NMIPAddress* addr) {
	NetworkWidgetsInfoBox* self;
	NMIPAddress* _tmp0_;
	gchar* inet_str = NULL;
	NMIPAddress* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	NMIPAddress* _tmp5_;
	guint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gint _tmp23_;
	GPtrArray* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp33_;
	self = _data8_->self;
	g_return_if_fail (addr != NULL);
	_tmp0_ = addr;
	nm_ip_address_ref (_tmp0_);
	_tmp1_ = addr;
	_tmp2_ = nm_ip_address_get_address (_tmp1_);
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = addr;
	_tmp6_ = nm_ip_address_get_prefix (_tmp5_);
	_tmp7_ = g_strdup_printf ("%u", _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp4_);
	inet_str = _tmp10_;
	_tmp11_ = self->priv->ip6address;
	_tmp12_ = self->priv->ip6address_head;
	_tmp13_ = inet_str;
	_tmp14_ = string_strip (_tmp13_);
	_tmp15_ = _tmp14_;
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, g_strcmp0 (_tmp15_, "") != 0);
	gtk_widget_set_visible ((GtkWidget*) _tmp11_, g_strcmp0 (_tmp15_, "") != 0);
	_g_free0 (_tmp15_);
	_tmp16_ = self->priv->ip6address;
	_tmp17_ = self->priv->ip6address;
	_tmp18_ = gtk_label_get_label (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = inet_str;
	_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
	_tmp22_ = _tmp21_;
	gtk_label_set_label (_tmp17_, _tmp22_);
	_g_free0 (_tmp22_);
	_tmp23_ = _data8_->i;
	_tmp24_ = _data8_->addresses;
	_tmp25_ = g_ptr_array_get_length (_tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp23_ < _tmp26_) {
		GtkLabel* _tmp27_;
		GtkLabel* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		_tmp27_ = self->priv->ip6address;
		_tmp28_ = self->priv->ip6address;
		_tmp29_ = gtk_label_get_label (_tmp28_);
		_tmp30_ = _tmp29_;
		_tmp31_ = g_strconcat (_tmp30_, "\n", NULL);
		_tmp32_ = _tmp31_;
		gtk_label_set_label (_tmp28_, _tmp32_);
		_g_free0 (_tmp32_);
	}
	_tmp33_ = _data8_->i;
	_data8_->i = _tmp33_ + 1;
	_g_free0 (inet_str);
}


static void ____lambda7__gfunc (gconstpointer data, gpointer self) {
	___lambda7_ (self, (NMIPAddress*) data);
}


void network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self) {
	NMIPConfig* ipv4 = NULL;
	NMDevice* _tmp0_;
	NMIPConfig* _tmp1_;
	NMIPConfig* _tmp2_;
	NMIPConfig* _tmp3_;
	NMIPConfig* ip6 = NULL;
	NMDevice* _tmp29_;
	NMIPConfig* _tmp30_;
	NMIPConfig* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	NMIPConfig* _tmp34_;
	GtkLabel* _tmp35_;
	NMIPConfig* _tmp36_;
	NetworkWidgetsDeviceItem* _tmp41_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = nm_device_get_ip4_config (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	ipv4 = _tmp2_;
	_tmp3_ = ipv4;
	if (_tmp3_ != NULL) {
		NMIPConfig* _tmp4_;
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		const gchar* _tmp22_ = NULL;
		NMIPConfig* _tmp23_;
		const gchar* _tmp24_;
		GtkLabel* _tmp25_;
		_tmp4_ = ipv4;
		_tmp5_ = nm_ip_config_get_addresses (_tmp4_);
		_tmp6_ = g_ptr_array_get_length (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_ > 0) {
			NMIPAddress* address = NULL;
			NMIPConfig* _tmp8_;
			GPtrArray* _tmp9_;
			gconstpointer _tmp10_;
			GtkLabel* _tmp11_;
			NMIPAddress* _tmp12_;
			const gchar* _tmp13_;
			guint32 mask_addr = 0U;
			NMIPAddress* _tmp14_;
			guint _tmp15_;
			struct in_addr source_addr = {0};
			guint32 _tmp16_;
			struct in_addr _tmp17_ = {0};
			const gchar* _tmp18_ = NULL;
			struct in_addr _tmp19_;
			const gchar* _tmp20_;
			GtkLabel* _tmp21_;
			_tmp8_ = ipv4;
			_tmp9_ = nm_ip_config_get_addresses (_tmp8_);
			_tmp10_ = g_ptr_array_index (_tmp9_, (guint) 0);
			address = (NMIPAddress*) _tmp10_;
			_tmp11_ = self->priv->ip4address;
			_tmp12_ = address;
			_tmp13_ = nm_ip_address_get_address (_tmp12_);
			gtk_label_set_label (_tmp11_, _tmp13_);
			_tmp14_ = address;
			_tmp15_ = nm_ip_address_get_prefix (_tmp14_);
			mask_addr = ~(((guint32) 0xffffffffLL) << _tmp15_);
			_tmp16_ = mask_addr;
			memset (&_tmp17_, 0, sizeof (struct in_addr));
			_tmp17_.s_addr = _tmp16_;
			source_addr = _tmp17_;
			_tmp19_ = source_addr;
			_tmp20_ = inet_ntoa (_tmp19_);
			_tmp18_ = _tmp20_;
			if (_tmp18_ == NULL) {
				_tmp18_ = NETWORK_UNKNOWN_STR;
			}
			_tmp21_ = self->priv->mask;
			gtk_label_set_label (_tmp21_, _tmp18_);
			 (source_addr);
		}
		_tmp23_ = ipv4;
		_tmp24_ = nm_ip_config_get_gateway (_tmp23_);
		_tmp22_ = _tmp24_;
		if (_tmp22_ == NULL) {
			_tmp22_ = NETWORK_UNKNOWN_STR;
		}
		_tmp25_ = self->priv->router;
		gtk_label_set_label (_tmp25_, _tmp22_);
	} else {
		GtkLabel* _tmp26_;
		GtkLabel* _tmp27_;
		GtkLabel* _tmp28_;
		_tmp26_ = self->priv->ip4address;
		gtk_label_set_label (_tmp26_, NETWORK_UNKNOWN_STR);
		_tmp27_ = self->priv->mask;
		gtk_label_set_label (_tmp27_, NETWORK_UNKNOWN_STR);
		_tmp28_ = self->priv->router;
		gtk_label_set_label (_tmp28_, NETWORK_UNKNOWN_STR);
	}
	_tmp29_ = self->priv->_device;
	_tmp30_ = nm_device_get_ip6_config (_tmp29_);
	_tmp31_ = _g_object_ref0 (_tmp30_);
	ip6 = _tmp31_;
	_tmp32_ = self->priv->ip6address;
	_tmp33_ = self->priv->ip6address_head;
	_tmp34_ = ip6;
	gtk_widget_set_visible ((GtkWidget*) _tmp33_, _tmp34_ != NULL);
	gtk_widget_set_visible ((GtkWidget*) _tmp32_, _tmp34_ != NULL);
	_tmp35_ = self->priv->ip6address;
	gtk_label_set_label (_tmp35_, "");
	_tmp36_ = ip6;
	if (_tmp36_ != NULL) {
		Block8Data* _data8_;
		NMIPConfig* _tmp37_;
		GPtrArray* _tmp38_;
		GPtrArray* _tmp39_;
		GPtrArray* _tmp40_;
		_data8_ = g_slice_new0 (Block8Data);
		_data8_->_ref_count_ = 1;
		_data8_->self = g_object_ref (self);
		_data8_->i = 1;
		_tmp37_ = ip6;
		_tmp38_ = nm_ip_config_get_addresses (_tmp37_);
		_tmp39_ = _g_ptr_array_ref0 (_tmp38_);
		_data8_->addresses = _tmp39_;
		_tmp40_ = _data8_->addresses;
		g_ptr_array_foreach (_tmp40_, ____lambda7__gfunc, _data8_);
		block8_data_unref (_data8_);
		_data8_ = NULL;
	}
	_tmp41_ = self->priv->_owner;
	if (_tmp41_ != NULL) {
		NetworkWidgetsDeviceItem* _tmp42_;
		_tmp42_ = self->priv->_owner;
		g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL], 0, _tmp42_);
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (ip6);
	_g_object_unref0 (ipv4);
}


NetworkWidgetsInfoBox* network_widgets_info_box_construct (GType object_type) {
	NetworkWidgetsInfoBox * self = NULL;
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, NULL);
	return self;
}


NetworkWidgetsInfoBox* network_widgets_info_box_new (void) {
	return network_widgets_info_box_construct (NETWORK_WIDGETS_TYPE_INFO_BOX);
}


NMDevice* network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self) {
	NMDevice* result;
	NMDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}


static void network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self, NMDevice* value) {
	g_return_if_fail (self != NULL);
	if (network_widgets_info_box_get_device (self) != value) {
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY]);
	}
}


NetworkWidgetsDeviceItem* network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self) {
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}


static void network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self, NetworkWidgetsDeviceItem* value) {
	g_return_if_fail (self != NULL);
	if (network_widgets_info_box_get_owner (self) != value) {
		NetworkWidgetsDeviceItem* _tmp0_;
		NetworkWidgetsDeviceItem* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_owner);
		self->priv->_owner = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY]);
	}
}


static void _network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self) {
	network_widgets_info_box_update_status (self);
	g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL], 0);
}


static void __network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender, guint new_state, guint old_state, guint reason, gpointer self) {
	_network_widgets_info_box___lambda8_ ((NetworkWidgetsInfoBox*) self);
}


static GObject * network_widgets_info_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsInfoBox * self;
	GtkImage* sent_head = NULL;
	GtkImage* _tmp0_;
	GtkLabel* _tmp1_;
	GtkGrid* sent_grid = NULL;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkImage* _tmp6_;
	GtkGrid* _tmp7_;
	GtkLabel* _tmp8_;
	GtkImage* received_head = NULL;
	GtkImage* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGrid* received_grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkImage* _tmp15_;
	GtkGrid* _tmp16_;
	GtkLabel* _tmp17_;
	GtkGrid* send_receive_grid = NULL;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkLabel* ip4address_head = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* mask_head = NULL;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* router_head = NULL;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkLabel* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkGrid* _tmp63_;
	GtkLabel* _tmp64_;
	NMDevice* _tmp65_;
	parent_class = G_OBJECT_CLASS (network_widgets_info_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("go-up-symbolic", GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp0_);
	sent_head = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->sent);
	self->priv->sent = _tmp1_;
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	sent_grid = _tmp2_;
	_tmp3_ = sent_grid;
	gtk_grid_set_column_spacing (_tmp3_, 12);
	_tmp4_ = sent_grid;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp4_, _ ("Sent"));
	_tmp5_ = sent_grid;
	_tmp6_ = sent_head;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = sent_grid;
	_tmp8_ = self->priv->sent;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("go-down-symbolic", GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp9_);
	received_head = _tmp9_;
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->received);
	self->priv->received = _tmp10_;
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp11_);
	received_grid = _tmp11_;
	_tmp12_ = received_grid;
	gtk_grid_set_column_spacing (_tmp12_, 12);
	_tmp13_ = received_grid;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Received"));
	_tmp14_ = received_grid;
	_tmp15_ = received_head;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = received_grid;
	_tmp17_ = self->priv->received;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp18_);
	send_receive_grid = _tmp18_;
	_tmp19_ = send_receive_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
	_tmp20_ = send_receive_grid;
	gtk_grid_set_column_spacing (_tmp20_, 12);
	_tmp21_ = send_receive_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 12);
	_tmp22_ = send_receive_grid;
	_tmp23_ = sent_grid;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = send_receive_grid;
	_tmp25_ = received_grid;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("IP Address:"));
	g_object_ref_sink (_tmp26_);
	ip4address_head = _tmp26_;
	_tmp27_ = ip4address_head;
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->ip4address);
	self->priv->ip4address = _tmp28_;
	_tmp29_ = self->priv->ip4address;
	gtk_label_set_selectable (_tmp29_, TRUE);
	_tmp30_ = self->priv->ip4address;
	gtk_label_set_xalign (_tmp30_, (gfloat) 0);
	_tmp31_ = (GtkLabel*) gtk_label_new (_ ("IPv6 Address:"));
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (self->priv->ip6address_head);
	self->priv->ip6address_head = _tmp31_;
	_tmp32_ = self->priv->ip6address_head;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp32_, TRUE);
	_tmp33_ = self->priv->ip6address_head;
	gtk_widget_set_halign ((GtkWidget*) _tmp33_, GTK_ALIGN_END);
	_tmp34_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->ip6address);
	self->priv->ip6address = _tmp34_;
	_tmp35_ = self->priv->ip6address;
	gtk_label_set_selectable (_tmp35_, TRUE);
	_tmp36_ = self->priv->ip6address;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp36_, TRUE);
	_tmp37_ = self->priv->ip6address;
	gtk_label_set_xalign (_tmp37_, (gfloat) 0);
	_tmp38_ = (GtkLabel*) gtk_label_new (_ ("Subnet mask:"));
	g_object_ref_sink (_tmp38_);
	mask_head = _tmp38_;
	_tmp39_ = mask_head;
	gtk_widget_set_halign ((GtkWidget*) _tmp39_, GTK_ALIGN_END);
	_tmp40_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->priv->mask);
	self->priv->mask = _tmp40_;
	_tmp41_ = self->priv->mask;
	gtk_label_set_selectable (_tmp41_, TRUE);
	_tmp42_ = self->priv->mask;
	gtk_label_set_xalign (_tmp42_, (gfloat) 0);
	_tmp43_ = (GtkLabel*) gtk_label_new (_ ("Router:"));
	g_object_ref_sink (_tmp43_);
	router_head = _tmp43_;
	_tmp44_ = router_head;
	gtk_widget_set_halign ((GtkWidget*) _tmp44_, GTK_ALIGN_END);
	_tmp45_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp45_);
	_g_object_unref0 (self->priv->router);
	self->priv->router = _tmp45_;
	_tmp46_ = self->priv->router;
	gtk_label_set_selectable (_tmp46_, TRUE);
	_tmp47_ = self->priv->router;
	gtk_label_set_xalign (_tmp47_, (gfloat) 0);
	_tmp48_ = ip4address_head;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp48_, 0, 0, 1, 1);
	_tmp49_ = self->priv->ip4address;
	_tmp50_ = ip4address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp49_, (GtkWidget*) _tmp50_, GTK_POS_RIGHT, 1, 1);
	_tmp51_ = self->priv->ip6address_head;
	_tmp52_ = ip4address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp51_, (GtkWidget*) _tmp52_, GTK_POS_BOTTOM, 1, 1);
	_tmp53_ = self->priv->ip6address;
	_tmp54_ = self->priv->ip6address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp53_, (GtkWidget*) _tmp54_, GTK_POS_RIGHT, 1, 1);
	_tmp55_ = mask_head;
	_tmp56_ = self->priv->ip6address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp55_, (GtkWidget*) _tmp56_, GTK_POS_BOTTOM, 1, 1);
	_tmp57_ = self->priv->mask;
	_tmp58_ = mask_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp57_, (GtkWidget*) _tmp58_, GTK_POS_RIGHT, 1, 1);
	_tmp59_ = router_head;
	_tmp60_ = mask_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp59_, (GtkWidget*) _tmp60_, GTK_POS_BOTTOM, 1, 1);
	_tmp61_ = self->priv->router;
	_tmp62_ = router_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp61_, (GtkWidget*) _tmp62_, GTK_POS_RIGHT, 1, 1);
	_tmp63_ = send_receive_grid;
	_tmp64_ = router_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp63_, (GtkWidget*) _tmp64_, GTK_POS_BOTTOM, 4, 1);
	_tmp65_ = self->priv->_device;
	g_signal_connect_object (_tmp65_, "state-changed", (GCallback) __network_widgets_info_box___lambda8__nm_device_state_changed, self, 0);
	network_widgets_info_box_update_status (self);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (router_head);
	_g_object_unref0 (mask_head);
	_g_object_unref0 (ip4address_head);
	_g_object_unref0 (send_receive_grid);
	_g_object_unref0 (received_grid);
	_g_object_unref0 (received_head);
	_g_object_unref0 (sent_grid);
	_g_object_unref0 (sent_head);
	return obj;
}


static void network_widgets_info_box_class_init (NetworkWidgetsInfoBoxClass * klass) {
	network_widgets_info_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetworkWidgetsInfoBoxPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_info_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_info_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_widgets_info_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_widgets_info_box_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL] = g_signal_new ("update-sidebar", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM);
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL] = g_signal_new ("info-changed", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void network_widgets_info_box_instance_init (NetworkWidgetsInfoBox * self) {
	self->priv = NETWORK_WIDGETS_INFO_BOX_GET_PRIVATE (self);
}


static void network_widgets_info_box_finalize (GObject * obj) {
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_owner);
	_g_object_unref0 (self->priv->ip4address);
	_g_object_unref0 (self->priv->ip6address);
	_g_object_unref0 (self->priv->mask);
	_g_object_unref0 (self->priv->router);
	_g_object_unref0 (self->priv->sent);
	_g_object_unref0 (self->priv->received);
	_g_object_unref0 (self->priv->ip6address_head);
	G_OBJECT_CLASS (network_widgets_info_box_parent_class)->finalize (obj);
}


GType network_widgets_info_box_get_type (void) {
	static volatile gsize network_widgets_info_box_type_id__volatile = 0;
	if (g_once_init_enter (&network_widgets_info_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsInfoBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_info_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsInfoBox), 0, (GInstanceInitFunc) network_widgets_info_box_instance_init, NULL };
		GType network_widgets_info_box_type_id;
		network_widgets_info_box_type_id = g_type_register_static (gtk_grid_get_type (), "NetworkWidgetsInfoBox", &g_define_type_info, 0);
		g_once_init_leave (&network_widgets_info_box_type_id__volatile, network_widgets_info_box_type_id);
	}
	return network_widgets_info_box_type_id__volatile;
}


static void _vala_network_widgets_info_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	switch (property_id) {
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
		g_value_set_object (value, network_widgets_info_box_get_device (self));
		break;
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
		g_value_set_object (value, network_widgets_info_box_get_owner (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_network_widgets_info_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	switch (property_id) {
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
		network_widgets_info_box_set_device (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
		network_widgets_info_box_set_owner (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



